﻿@model SalesOrderItemsFormView

@{
    string test = "";
    bool _View = ((UserView)Session["UserLogin"]).ListUserPageAction.Where(c => c.PageInternalKey == Enums.Pages.SalesOrder.ToDescriptionString() && c.InternalKey == Enums.Actions.View.ToDescriptionString()).FirstOrDefault() != null ? true : false;
    string itemRecargo = System.Web.Configuration.WebConfigurationManager.AppSettings["Recargo"];
    bool esRecargo = false;
}

<script type="text/javascript">
    var DistrRuleItems = [];
    var GLItems = [];

    $.ajax({
        url: '/Sales/SalesOrder/_GetDistributionRuleList',
        type: 'POST',
        data: {},
        traditional: true,
        cache: false,
        async: true,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {

                DistrRuleItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });

            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)

        },
    });
    $.ajax({
        url: '/Sales/SalesOrder/_GetGLAccountList',
        type: 'POST',
        data: { pPageKey: "@ViewBag.PageKey" },
        traditional: true,
        cache: false,
        async: true,
        dataType: 'json',
        success: function (data) {
            $.each(data, function (key) {
                GLItems.push({
                    value: data[key].Value,
                    label: data[key].Text
                });
            });
        }, error: function (xhr) {
            ErrorCalls(xhr.status)

        },
    });
</script>

<div id="TableItemsForm">
    <table class="table table-striped SalesOrderTable">
        <thead>
            <tr>

                <th>&nbsp;</th>
                <th>&nbsp;</th>
                <th>&nbsp;</th>
                <th><strong><label id="lblItem" contenteditable='true'>@PurchaseOrders.Item</label></strong></th>
                @if (Model.CkCatalogNum == true)
                {
                    <th><strong><label contenteditable='true'>@PurchaseOrders.BPCN</label></strong></th>
                }
                <th><strong><label id="lblDesc" contenteditable='true'>@PurchaseOrders.Description</label></strong></th>
                <th><strong>Batch</strong></th>
                <th><strong><label id="lblQty" contenteditable='true'>@PurchaseOrders.Qty</label></strong></th>
                <th></th>
                <th><strong><label id="lblOpenQty" contenteditable='false'>@SaleOrders.OpenQty</label></strong></th>

                @if (Model.ShowOpenQuantity)
                {
                    <th><strong>@PurchaseOrders.OpenQuantity</strong></th>
                }

                <th><strong>@PurchaseOrders.Currency</strong></th>
                <th><strong><label id="lblPrice" contenteditable='true'>@PurchaseOrders.Price</label></strong></th>
                <th><strong>@PurchaseOrders.Discount %</strong></th>
                <th><strong>@PurchaseOrders.PAD</strong></th>
                <th><strong>@PurchaseOrders.TaxCode</strong></th>
                <th><strong>@PurchaseOrders.Tax %</strong></th>
                <th><strong>@PurchaseOrders.GrossPrice</strong></th>
                <th><strong>Total (LC)</strong></th>
                <th><strong>@PurchaseOrders.WC</strong></th>
                <th><strong>Stock</strong></th>
                <th><strong>@PurchaseOrders.DelDate</strong></th>
                <th><strong>@PurchaseOrders.GLA</strong></th>
                <th><strong>@PurchaseOrders.Project</strong></th>
                <th><strong>@PurchaseOrders.PriceSource</strong></th>
                <th><strong>@PurchaseOrders.TaxAmount</strong></th>
                <th><strong>@PurchaseOrders.Freight 1</strong></th>
                <th><strong>@PurchaseOrders.Freight (LC)</strong></th>
                <th><strong>@PurchaseOrders.FT</strong></th>
                <th><strong>@PurchaseOrders.UOMGroup</strong></th>
                <th><strong>@PurchaseOrders.UOM</strong></th>
                <th><strong>@PurchaseOrders.GrossTotal</strong></th>
                <th><strong>@PurchaseOrders.DR</strong></th>
                <th><strong>@PurchaseOrders.DR 2</strong></th>
                @{
                    if (Model.Lines.Count > 0)
                    {
                        if (Model.Lines.FirstOrDefault().MappedUdf != null && Model.Lines.FirstOrDefault().MappedUdf.Count > 0)
                        {
                            foreach (var DictRow in Model.Lines.FirstOrDefault().MappedUdf.OrderBy(c => c.UDFName))
                            {
                                <th><strong>@DictRow.UDFDesc</strong></th>
                            }
                        }
                    }
                }
            </tr>
        </thead>
        <tbody>
            @if (Model != null)
            {
                string mTAuto;
                string mTAutoDR;
                string mTAutoDR2;
                string mDescItem;
                string mItemCode;
                string mTAutoGLAccount;
                string mProjectSAP;
                string mFreeTxt;
                string mDelDate;
                string mTxtId;
                string mSpecPrice;
                string mTdId;
                string mDpId;
                string mTxtCountId;
                string mUomGroupCode;
                string mUomGroupName;
                string mUomCode;
                string mSerialBatch;
                string mFreight1;
                string mFreightLC1;
                string mTrId;
                string currencySelected;
                double mTotal = 0;
                string mUOMAuto;
                string mlistUOM;

                string mDiscPrcnt;
                string mTaxCode;
                string mVatPrcnt;
                string mPriceAfVAT;
                string mVatSum;
                string mGTotal;
                string mPriceDisc;
                string mTxtOpentId;
                string mhdId;
                string mTree;

                foreach (SaleOrderLineView item in Model.Lines)
                {
                    mTAuto = "AutoComplete" + item.LineNum;
                    mTAutoDR = "AutoCompleteDR" + item.LineNum;
                    mTAutoDR2 = "AutoCompleteDR_2" + item.LineNum;
                    mDescItem = "DescItem" + item.LineNum;
                    mItemCode = "ItemCode" + item.LineNum;
                    mTAutoGLAccount = "AutoCompleteGL" + item.LineNum;
                    mProjectSAP = "ProjectSAP" + item.LineNum;
                    mFreeTxt = "FreeTxt" + item.LineNum;
                    mDelDate = "DelDate" + item.LineNum;
                    mTxtId = "txt" + item.LineNum;
                    mSpecPrice = "SpecPrice" + item.LineNum;
                    mTdId = "td" + item.LineNum;
                    mDpId = "dp" + item.LineNum;
                    mTxtCountId = "txtcount" + item.LineNum;
                    mUomCode = "txtUomCode" + item.LineNum;
                    mUomGroupName = "txtUomGroupName" + item.LineNum;
                    mSerialBatch = "txtSerialBatch" + item.LineNum;
                    mFreight1 = "Freight1" + item.LineNum;
                    mFreightLC1 = "FreightLC1" + item.LineNum;
                    mTrId = "tr" + item.LineNum;
                    currencySelected = (!string.IsNullOrEmpty(item.Currency) ? item.Currency : Model.DocCur ?? "").ToString().Trim();
                    mTotal = 0;
                    mUOMAuto = "UOMAuto" + item.LineNum;
                    mlistUOM = "listUOM" + item.LineNum;
                    mTree = "tree" + item.LineNum;

                    mDiscPrcnt = "DiscPrcnt" + item.LineNum;
                    mTaxCode = "TaxCode" + item.LineNum;
                    mVatPrcnt = "VatPrcnt" + item.LineNum;
                    mPriceAfVAT = "PriceAfVAT" + item.LineNum;
                    mVatSum = "VatSum" + item.LineNum;
                    mGTotal = "GTotal" + item.LineNum;
                    mPriceDisc = "Price" + item.LineNum;
                    mTxtOpentId = "txtOpenQty" + item.LineNum;
                    mhdId = "hd" + item.LineNum;
                    esRecargo = (item.ItemCode == itemRecargo ? true : false);

                    if (item.RateGl == 0 || item.RateLine == 0)
                    {
                        <script type="text/javascript">
                                        $('#alertRates').show();
                            $('#btnOk').attr("disabled", true);
                        </script>
                                }
                                else
                                {
                                    mTotal = (((double)item.Price) / item.RateGl) * item.RateLine;
                        <script type="text/javascript">
                                        $('#alertRates').hide();
                            $('#btnOk').attr("disabled", false);
                        </script>
                                }
                    <tr id='@mTrId'>

                        <td>
                            @if (item.LineStatus == "O" || item.LineStatus == null)
                                        {
                                <button onclick="DeleteRow('@item.LineNum')" type="button" class="btn btn-primary btn-xs"><span class="glyphicon glyphicon-trash"></span> </button>
                            }
                            <input type="hidden" id="@item.LineNum" value="@item.CalcTax" />
                            <input id="BaseType_@item.LineNum" value="@item.BaseType" style="display:none" />
                            <input id="BaseEntry_@item.LineNum" value="@item.BaseEntry" style="display:none" />
                            <input id="BaseLine_@item.LineNum" value="@item.BaseLine" style="display:none" />
                            <input id="BaseRef_@item.LineNum" value="@item.BaseRef" style="display:none" />
                        </td>
                        <td>
                            @if (_View)
                {
                                <a href='@Url.Action("ActionItemMaster", "MasterData", new {  Area = "MasterData",@pActionItemMaster = "View", @pItemCode = item.ItemCode })' class="btn btn-primary btn-xs" target="_blank">
                                    <span class="glyphicon glyphicon-eye-open"></span>
                                </a>
                            }
                        </td>
                        <td>
                            <div class="btn-group dropup">
                                <button type="button" class="btn btn-danger dropdown-toggle dropdown-toggle-split boton_drop_split" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                    <b class="glyphico glyphicon glyphicon-download"></b>
                                </button>
                                <div class="dropdown-menu menu_drop_interno">
                                    <a class="dropdown-item" href="#" onclick="ShowComplementaries('@item.ItemCode','@item.Dscription')"><span class="glyphicon glyphicon-indent-left"></span> Alternativos</a>
                                </div>
                            </div>
                        </td>
                        <td><input id='@mItemCode' class="form-control item_desc_table" value='@item.ItemCode' disabled="disabled" /></td>
                        @if (Model.CkCatalogNum == true)
            {
                            <td><input class="form-control item_desc_table" value='@item.Substitute' disabled="disabled" /></td>
                        }
                        <td><input id='@mDescItem' class="form-control descDocuments" value='@item.Dscription' onchange="LineWasChanged('@item.LineNum');" /></td>
                        <td><input id='@mSerialBatch' class="form-control descDocuments" value='@item.SerialBatch' onchange="LineWasChanged('@item.LineNum');" /></td>
                        <td><input type="number" id='@mTxtCountId' onblur="ReloadLines();" onkeydown="OpenSerialPopup('@item.DocEntry','@item.LineNum','@(Model.UsersSetting.DftWhs == null ? item.WhsCode : Model.UsersSetting.DftWhs)', '@item.ItemCode','@item.ManSerNum', '@item.anoSelected');" name="serialbatch" class="form-control quantityDocuments" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Quantity, item.Quantity))' onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum',true,'@esRecargo'); ChangeQuantityValue('@item.LineNum', '@Shared.NumberGreaterZero');" /></td>
                        <td>
                            @if (item.ManSerNum == "Y")
            {
                                <a href='#'>
                                    <span class="glyphicon glyphicon-barcode" onclick="OpenSerialPopuFromButton('@item.DocEntry','@item.LineNum','@(Model.UsersSetting.DftWhs == null ? item.WhsCode : Model.UsersSetting.DftWhs)', '@item.ItemCode','@item.anoSelected');"></span>
                                </a>
                            }
                        </td>
                        <td><input type="number" id='@mTxtOpentId' class="form-control quantityDocuments" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Quantity, item.OpenQty  ))' disabled="disabled" /></td>
                        @if (Model.ShowOpenQuantity)
            {
                switch (item.OpenQuantityStatus)
                {
                    case OpenQuantityStatus.Green:
                                    <td><span class="dot" style="background-color:green" title="@PurchaseOrders.OpenQuantityGreen"></span></td>
                                    break;
                                case OpenQuantityStatus.Red:
                                    <td><span class="dot" style="background-color:red" title="@PurchaseOrders.OpenQuantityRed"></span></td>
                                    break;
                                case OpenQuantityStatus.Yellow:
                                    <td><span class="dot" style="background-color:yellow" title="@PurchaseOrders.OpenQuantityYellow"></span></td>
                                    break;
                                default:
                                    break;
                            }
                        }


                        <td>@Html.DropDownListFor(c => test, new SelectList(item.ListCurrency, "CurrCode", "CurrName", currencySelected), new { @Id = mDpId, @class = "form-control currencyDocuments", @onchange = "LineWasChanged('" + @item.LineNum + "'); ChangeValue('" + @item.LineNum + "',true,'" + esRecargo + "')" })</td>
                        <td><input onblur="ReloadLines();" onchange="LineWasChanged('@item.LineNum'); ChangeValue('@item.LineNum',true);" type="number" class="form-control priceDocuments" id='@mTxtId' value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, item.PriceBefDi))' /></td>
                        <td><input type="number" id='@mDiscPrcnt' class="form-control" value='@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Percent, (item.DiscPrcnt != null ? item.DiscPrcnt.Value : 0)))' onblur="ReloadLines();" onchange="LineWasChanged('@item.LineNum');ChangeValue('@item.LineNum',true,'@esRecargo');" title="type &quot;a&quot;"></td>
                        <td id='@mPriceDisc'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, item.Price))</td>
                        <td><input id='@mTaxCode' class="form-control autoComplete" value="@(!string.IsNullOrEmpty(item.TaxCode) ? item.TaxCode : ((Model.LawsSet == "AR") ? (item.TaxCodeAR) : string.Empty))" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td id='@mVatPrcnt'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Percent, (item.VatPrcnt != null ? item.VatPrcnt.Value : 0)))</td>
                        <td id='@mPriceAfVAT'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.PriceAfVAT != null ? item.PriceAfVAT.Value : 0)))</td>
                        <td id='@mTdId'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (decimal)mTotal))</td>
                        <td><input id='@mTAuto' name="whs" class="form-control autoComplete" value="@(Model.UsersSetting.DftWhs == null ? item.WhsCode : Model.UsersSetting.DftWhs)" onblur="ReloadLines();" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td>
                            <a href='#'>
                                @if (item.hasStock)
                                {
                                    <span class="glyphicon glyphicon-ok" onclick="GetStock('@item.ItemCode')"></span>
                                }
                                else
                                {
                                    <span class="glyphicon glyphicon-remove" onclick="GetStock('@item.ItemCode')"></span>
                                }
                            </a>
                        </td>
                        <td>
                            <div class="input-group date dateDocuments">
                                <input value="@((item.ShipDate != null && item.ShipDate != DateTime.MinValue) ? item.ShipDate.ToString().AsDateTime().ToShortDateString() : ((Model.ReqDate != null && Model.ReqDate != DateTime.MinValue) ? Model.ReqDate.ToString().AsDateTime().ToShortDateString() : ""))" class="form-control valid" data-val="true" data-val-date=" must be a date." id="@mDelDate" name="@mDelDate" onchange="LineWasChanged('@item.LineNum');" placeholder="@PurchaseOrders.DelDate" type="text"><span class="input-group-addon"><i class="glyphicon glyphicon-calendar"></i></span>
                            </div>
                        </td>
                        <td><input id='@mTAutoGLAccount' class="form-control autoCompleteGLAccount" value="@(item.GLAccount != null ? item.GLAccount.FormatCode : "")" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td style="display: inline-flex;"><input id='@mProjectSAP' class="form-control" value="@item.Project" onchange="LineWasChanged('@item.LineNum');"><a class="SearchProjectButton" href="#"><span class="glyphicon glyphicon-search" data-toggle="modal" data-target="#ModalProjects" onclick="SetLineToSetProjectSAP(@item.LineNum)"></span></a></td>
                        <td><input id='@mSpecPrice' class="form-control" value='@item.SpecPrice' onchange="LineWasChanged('@item.LineNum');" disabled="disabled" /></td>
                        <td id='@mVatSum'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.VatSum != null ? item.VatSum.Value : 0)))</td>
                        <td>
                            @Html.DropDownListFor(c => test, new SelectList(Model.FreightList, "ExpnsCode", "ExpnsName", (item.Freight.FirstOrDefault() != null ? item.Freight.FirstOrDefault().ExpnsCode : null)), new { @Id = mFreight1, @class = "form-control currencyDocuments", @onchange = "LineWasChanged('" + item.LineNum + "');" })
                        </td>
                        <td><input id='@mFreightLC1' onchange="UpdateFreightByLine('@mFreightLC1'); LineWasChanged('@item.LineNum');" class="form-control descDocuments" value='@(item.Freight.FirstOrDefault() != null ? item.Freight.FirstOrDefault().LineTotal : null)' /></td>
                        <td><input id='@mFreeTxt' class="form-control autoCompleteGLAccount" placeholder="@PurchaseOrders.FT" value="@(item.FreeTxt)" onchange="LineWasChanged('@item.LineNum');"></td>
                        <td>
                            <input id='@mUomGroupName' class="form-control" placeholder="@PurchaseOrders.UOMGroup" value="@(item.UomGroupName)" disabled="disabled">
                        </td>
                        <td>
                            <input id="@mUOMAuto" list="@mlistUOM" value="@(item.UomCode != null ? item.UomCode : string.Empty)" onchange="LineWasChanged('@item.LineNum'); UpdateUOM('@item.LineNum');" class="form-control uomDocument">
                            <datalist id="@mlistUOM">
                                @foreach (UnitOfMeasure mUOMAux in item.UnitOfMeasureList)
                                {
                                    <option value="@mUOMAux.UomCode">@mUOMAux.UomName</option>
                                }
                            </datalist>
                        </td>
                        <td id='@mGTotal'>@(((UserView)Session["UserLogin"]).CompanyConnect.FormatNumberWithDecimals(Enums.Decimals.Price, (item.GTotal != null ? item.GTotal.Value : 0)))</td>
                        <td><input id='@mTAutoDR' class="form-control autoComplete" value="@(item.OcrCode != null ? item.OcrCode : Model.UsersSetting.DftDistRule)" onchange="LineWasChanged('@item.LineNum');" title="type &quot;a&quot;"></td>
                        <td>
                            <input id='@mTAutoDR2' class="form-control autoComplete" value="@(item.OcrCode2 != null ? item.OcrCode2 : "")" onchange="LineWasChanged('@item.LineNum');" />
                            <input id='@mhdId' style="display:none;" value='@item.anoSelected' />
                            <input id='@mTree' style="display:none;" value='@item.TreeType' />
                        </td>
                        @{
                            if (Model.Lines.Count > 0)
                            {
                                if (Model.Lines.FirstOrDefault().MappedUdf != null && Model.Lines.FirstOrDefault().MappedUdf.Count > 0)
                                {
                                    foreach (var DictRow in item.MappedUdf.OrderBy(c => c.UDFName))
                                    {
                                        <td>
                                            @if (DictRow.ListUFD1.Count > 0)
            {
                @Html.DropDownList(DictRow.UDFName, new SelectList(
                         DictRow.ListUFD1,
                        "FldValue",
                         "Descr", DictRow.Value), new { @Id = "LINEUDF_" + DictRow.UDFName + item.LineNum, @Name = "LINEUDF_" + DictRow.UDFName, @class = "form-control UDFField", @onchange = "LineWasChanged('" + item.LineNum + "');" })
                                            }
                                            else
                                            {
                                                <input id='LINEUDF_@DictRow.UDFName@item.LineNum' name="LINEUDF_@DictRow.UDFName" class="form-control UDFField" value='@DictRow.Value' onchange="LineWasChanged('@item.LineNum');" />
                                            }
                                        </td>
                                    }
                                }
                            }
                        }
                    </tr>
                    <script type="text/javascript">

                        $("#" + '@mTAuto').autocomplete({
            source: function (request, response) {
                                $.ajax({
                    url: '/Sales/SalesOrder/GetWHwithStock',
                                    type: 'POST',
                                    data: { ItemCode: '@item.ItemCode' },
                                    async: true,
                                    dataType: 'json',
                                    success: function (data) {
                            var Whitems = [];

                                        $.each(data, function (key) {

                                Whitems.push({
                                value: data[key].WhsCode,
                                                label: data[key].WhsName
                                            });

                            });

                            response(Whitems);

                        }, error: function (xhr) {
                            ErrorCalls(xhr.status)

                                    },
                                });

                },
                            minLength: 2
                        });

                        $("#" + '@mTAutoDR').autocomplete({
            source: DistrRuleItems
                        });

                        $("#" + '@mTAutoGLAccount').autocomplete({
            source: GLItems
                        });

                        //Tax Code List Autocomplete
                        $("#" + '@mTaxCode').autocomplete({

            minLength: 1,
                            source: function (request, response) {
                                $.ajax({
                    url: '/Sales/SalesOrder/GetTaxCodeList',
                                    type: 'POST',
                                    async: true,
                                    dataType: 'json',
                                    success: function (data) {
                            var mTaxCodeList = [];

                                        $.each(data, function (key) {

                                mTaxCodeList.push({
                                value: data[key].Code,
                                                label: data[key].Name,
                                                rateval: data[key].Rate
                                            });

                            });
                            response(mTaxCodeList);

                        }, error: function (xhr) {
                            ErrorCalls(xhr.status)

                                    },
                                });

                },
                            select: function (event, ui) {
                                $("#" + '@mVatPrcnt').html(ui.item.rateval);
                    ChangeValue('@item.LineNum', true,'@esRecargo');

                }
            });

                    </script>
                }
            }
        </tbody>
    </table>
</div>

<script type="text/javascript">

    $("#RightLateralMessageContent").html("@SaleOrders.IWACTTO");

    function GetStock(item) {

        $.ajax({
            url: '/Sales/SalesOrder/GetItemStock',
            contextType: 'application/html;charset=utf-8',
            data: { ItemCode: item },
            async: true,
            type: 'POST',
            dataType: 'html'
        }).done(function (data) {

            alertify.alert(data);

        });
    }

    var pastedData;
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf("MSIE ");

    if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))  // If Internet Explorer, return version number
    {

        var ctrlDown = false;
        var ctrlKey = 17, vKey = 86, cKey = 67;

        $("#lblItem").keydown(function (e) {
            if (e.ctrlKey && e.keyCode == 86) {
                PullCopyPaste(window.clipboardData.getData('Text'));
            }
        });

    }
    else {

        $("#lblItem").bind("paste", function (e) {

            PullCopyPaste(e.originalEvent.clipboardData.getData('text'));

        });
    }

    function PullCopyPaste(pClipBoard) {
        var mListItems = [];

        $('#ckCode').prop('checked', true);
        $('#ckName').prop('checked', true);
        $('#txtSearch').val('');

        var pastedData = pClipBoard;

        var rows = pastedData.split("\n");

        for (var y in rows) {

            var cells = rows[y].split("\t");

            for (var x in cells) {
                if (cells[x] != "") {

                    mListItems.push(cells[x].replace(/(\r\n|\n|\r)/gm, ""));

                }
            }

        }

        if (mListItems.length == 0) {
            return;
        }

        $('#Loading').modal({
            backdrop: 'static',
            keyboard: true
        });

        var mTypeCurrency = "";

        switch ($("#TypeCurrency").val()) {
            case "C":
                $("#txtCurrencySg").show();
                mTypeCurrency = $("#txtCurrencySg").val();
                break;
            case "L":
                $("#txtCurrencySg").hide();
                mTypeCurrency = $("#LocalCurrency").val();
                break;
            case "S":
                $("#txtCurrencySg").hide();
                mTypeCurrency = $("#SystemCurrency").val();
                break;
        }
        var pReqDate;
        if (isNaN($("#ReqDate").datepicker("getDate"))) {
            pReqDate == null;
        }
        else {
            var dateReqDate = $("#ReqDate").datepicker("getDate");
            pReqDate = (isNaN(dateReqDate) == true ? null : (dateReqDate.getMonth() + 1) + "/" + dateReqDate.getDate() + "/" + dateReqDate.getFullYear());
        }

        $.ajax({
            url: '/Sales/SalesOrder/_ItemsFormCopyPaste',
            traditional: true,
            contextType: 'application/html;charset=utf-8',
            data: { pItems: mListItems, pCurrency: mTypeCurrency, CardCode: $("#txtCodeVendor").val(), pReqDate: pReqDate, pPageKey: $('#Pagekey').val() },
            type: 'POST',
            dataType: 'html'
        }).done(function (data) {
            $('#myModal').modal('hide');
            //$("#ItemsSelect").html(data);
            $('#Loading').modal('hide');
            $("#ItemsSelect").html(data).trigger('change');
        });
    }

    $("#lblDesc").bind("paste", function (e) {

        var mDesc = $("#lblDesc").text();

        var pastedData;
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf("MSIE ");

        if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {
            pastedData = window.clipboardData.getData('Text');
        }
        else {

            pastedData = e.originalEvent.clipboardData.getData('text');
        }

        var rows = pastedData.split("\n");
        var mLine = 0;
        for (var y in rows) {

            var cells = rows[y].split("\t");

            for (var x in cells) {

                if (cells[x] != "") {

                    $("#DescItem" + mLine).val(cells[x].replace(/(\r\n|\n|\r)/gm, ""));
                }
            }
            mLine++;
        }

        setTimeout(function () {
            $("#lblDesc").empty();
            $("#lblDesc").append(mDesc);
        }, 10);

    });

    $("#lblQty").bind("paste", function (e) {

        var mQty = $("#lblQty").text();

        var pastedData;
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf("MSIE ");

        if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {
            pastedData = window.clipboardData.getData('Text');
        }
        else {

            pastedData = e.originalEvent.clipboardData.getData('text');
        }

        var rows = pastedData.split("\n");
        var mLine = 0;
        for (var y in rows) {

            var cells = rows[y].split("\t");

            for (var x in cells) {

                if (cells[x] != "") {

                    $("#txtcount" + mLine).val(cells[x].replace(/(\r\n|\n|\r)/gm, ""));
                    ChangeValue(mLine, true,'@esRecargo');
                    LineWasChanged(mLine);

                }
            }
            mLine++;
        }

        setTimeout(function () {
            $("#lblQty").empty();
            $("#lblQty").append(mQty);
        }, 10);

    });

    $("#lblPrice").bind("paste", function (e) {

        var mPrice = $("#lblPrice").text();

        var pastedData;
        var ua = window.navigator.userAgent;
        var msie = ua.indexOf("MSIE ");

        if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./)) {
            pastedData = window.clipboardData.getData('Text');
        }
        else {

            pastedData = e.originalEvent.clipboardData.getData('text');
        }

        var rows = pastedData.split("\n");
        var mLine = 0;
        for (var y in rows) {

            var cells = rows[y].split("\t");

            for (var x in cells) {

                if (cells[x] != "") {

                    $("#txt" + mLine).val(cells[x].replace(/(\r\n|\n|\r)/gm, ""));

                    var ItemCode = $("#ItemCode" + mLine).val();
                    var esRecargo = "False";

                    if (ItemCode == '@itemRecargo') {
                        esRecargo = "True";
                    }

                    ChangeValue(mLine, true, esRecargo);
                    LineWasChanged(mLine);


                }
            }
            mLine++;
        }

        setTimeout(function () {
            $("#lblPrice").empty();
            $("#lblPrice").append(mPrice);

        }, 10);

    });


    $(document).ready(function () {
        $('.input-group.date').datepicker({});
        var mRead = '@ViewBag.CalculateRate';
        if (mRead == "Y") {
            CalculateTaxForAllLine();
        }
    });

    function CalculateTaxForAllLine() {
        var mIntRow = 0;
        $("#TableItemsForm :input[type=hidden]").each(function () {
            mIntRow++;
            var input = $(this);
            var mLineId = input.attr('id');

            var ItemCode = $("#ItemCode" + mLineId).val();
            var esRecargo = "False";

            if (ItemCode == '@itemRecargo') {
                esRecargo = "True";
            }

            ChangeValue(mLineId, false,esRecargo);

        });

        if (mIntRow > 0) {
            $('#alertItems').hide();
            CalculatedTotal();
        }
        else {
            $("#TotalDoc").val(0);
            $("#TotalDocPD").val($("#TotalExpns").val());
            $("#DiscPrcnt").val(0);
            $("#TotalDisc").val(0);

        }

    }

</script>